#!/bin/sh
# Copyright (C) 2005, 2006 Etersoft
# Copyright (C) 2005, 2006 Vitaly Lipatov <lav@etersoft.ru>
# Copyright (C) 2005 Nikolay Lezzhov <nick@etersoft.ru>
# Copyright (C) 2006 Konstantin Petrov <argentum@etersoft.ru>
#
# Place device mapping here
# Called from wine script
# FIXME: We need to detect CD drive path

OSNAME=`uname`

case "$OSNAME" in
"FreeBSD")
#echo "freebsd"
COMDEVICE=cuaa;
[ -c /dev/cuad0 ] && COMDEVICE=cuad;
LPTDEVICE=lpt;
CDFSNAME="cd9660";;
"Linux")
#echo "linux"
COMDEVICE=ttyS;
LPTDEVICE=lp;
CDFSNAME="iso9660";
[ -n "$LINUXXP" ] && CDFSNAME="managed";;
esac

## Configure CDROMs
#STARTCDLETTER=e

#CDDEVS=`cat /etc/fstab|grep $CDFSNAME| \
#perl -e while\(\<\>\)\{\@ss=split\;print\ \""\\$"ss\[0\]\ \"\;\}`

#CDMNTP=`cat /etc/fstab|grep $CDFSNAME| \
#perl -e while\(\<\>\)\{\@ss=split\;print\ \""\\$"ss\[1\]\ \"\;\}`

#cdlcode=`perl -e print\ ord\($STARTCDLETTER\)`

#for i in $CDMNTP ; do
#CDLETTER=`perl -e print\ chr\($cdlcode\)`
#if [ ${CDLETTER} = "{" ] ; then
#echo "WARNING: no more letters for CD-ROMs!"
#break
#fi
#map_drive $i ${CDLETTER}:
#cdlcode=$((cdlcode+1))
#done

#cdlcode=`perl -e print\ ord\($STARTCDLETTER\)`

#for i in $CDDEVS ; do
#CDLETTER=`perl -e print\ chr\($cdlcode\)`
#if [ ${CDLETTER} = "{" ] ; then
#echo "WARNING: no more letters for CD-ROMs!"
#break
#fi
#map_drive $i ${CDLETTER}::
#cdlcode=$((cdlcode+1))
#done


## Configure Floppy's
#FLOPDEVICE=/dev/fd0
#[ -c $FLOPDEVICE ] && {
#    FLOPMNTP=`cat /etc/fstab|grep $FLOPDEVICE|perl -e while\(\<\>\)\{\@ss=split\;print\ \""\\$"ss\[1\]\ \"\;\}`
#    #echo $FLOPMNTP
#    if [ x$FLOPMNTP != x"" ] ; then
#        map_drive $FLOPMNTP a:
#        map_drive $FLOPDEVICE a::
#    fi
#}


# the first character number 65 is 'e' 
LABEL=65

MNTBASE=/mnt
for i in `ls -d1 /media/cd* /media/dvd* 2>/dev/null`;
do
    if [ -d "$i" ] ; then {
        map_drive $i "`echo -e "\x$LABEL"`:"
	# FIXME: all cd & dvd drives are mounted to /dev/cdrom
	map_drive /dev/cdrom "`echo -e "\x$LABEL"`::"
	MNTBASE=/media
    } fi
    let LABEL=LABEL+1
done

################################################################

# You can change default device mapping preferences for WINE here

[ -d $MNTBASE/floppy ] && map_drive $MNTBASE/floppy a: && map_drive /dev/fd0 a::

# Creating Documents-path
[ -d ~/Documents ] && map_drive ~/Documents d: || map_drive ~/ d:

[ $MNTBASE == /mnt ] && [ -d $MNTBASE/cdrom ] && map_drive $MNTBASE/cdrom e: && map_drive /dev/cdrom e::

# Creating COM-ports
for i in 0 1 2 3  ; do
[ -c /dev/${COMDEVICE}$i ] && map_drive /dev/${COMDEVICE}$i com$((i+1))
done

# Creating LPT-ports
for i in 0 1 2 3  ; do
[ -c /dev/${LPTDEVICE}$i ] && map_drive /dev/${LPTDEVICE}$i lpt$((i+1))
done

# Uncomment for use home dir as WINE disk (not recommended)
#map_drive ~ f:

# Use root filesystem as WINE disk (not recommended)
[ -n "$LINUXXP" ] && map_drive / z:

# Map shared base dir
[ -d /var/local/sharebase ] && map_drive /var/local/sharebase s:
